<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "sales_analysis_setting".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SalesAnalysisSetting".
 *
 * Columns in table "sales_analysis_setting" available as properties of the model,
 * followed by relations of table "sales_analysis_setting" available as properties of the model.
 *
 * @property integer $id
 * @property integer $sales_analysis_id
 * @property integer $prospect_id
 * @property integer $organization_id
 * @property string $date_added
 * @property integer $base
 *
 * @property Organization $organization
 * @property Prospect $prospect
 * @property SalesAnalysis $salesAnalysis
 */
abstract class BaseSalesAnalysisSetting extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'sales_analysis_setting';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SalesAnalysisSetting|SalesAnalysisSettings', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('sales_analysis_id', 'required'),
            array('sales_analysis_id, prospect_id, organization_id, base', 'numerical', 'integerOnly'=>true),
            array('date_added', 'safe'),
            array('prospect_id, organization_id, date_added, base', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, sales_analysis_id, prospect_id, organization_id, date_added, base', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'organization' => array(self::BELONGS_TO, 'Organization', 'organization_id'),
            'prospect' => array(self::BELONGS_TO, 'Prospect', 'prospect_id'),
            'salesAnalysis' => array(self::BELONGS_TO, 'SalesAnalysis', 'sales_analysis_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'sales_analysis_id' => null,
            'prospect_id' => null,
            'organization_id' => null,
            'date_added' => Yii::t('app', 'Date Added'),
            'base' => Yii::t('app', 'Base'),
            'organization' => null,
            'prospect' => null,
            'salesAnalysis' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('sales_analysis_id', $this->sales_analysis_id);
        $criteria->compare('prospect_id', $this->prospect_id);
        $criteria->compare('organization_id', $this->organization_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('base', $this->base);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
